--LOCAL VARIABLES
local foodID, flaskID, potionID, blockTrades, targetName, targetRealm, buffLookUp, foundName, tradeSlot, tradeLoopCount, splitLoopCount;
local f = CreateFrame("Frame");
local waitTable = {};
local waitFrame = nil;

--ON LOAD
function RBDT_OnLoad(self)
	RBDT_Frame:RegisterEvent("PLAYER_LOGIN");
	RBDT_Frame:RegisterEvent("PLAYER_LOGOUT");
	self:RegisterForDrag("LeftButton");
	--TODO escape close window as option
	--tinsert(UISpecialFrames, RBDT_Frame:GetName())
	RBDT_txtPullCount:SetNumeric(true);
	RBDT_txtHours:SetNumeric(true);
end

--CLOSE WINDOW
function RBDT_btnCLOSE_CLICK(self, button, down)
	RBDT_Frame:Hide();
end

--TOGGLE TRADE WINDOW
function RBDT_Toggle()
	if (RBDT_Frame:IsShown()) then
		RBDT_Frame:Hide();
	else
		RBDT_Frame:Show();
	end
end

--GENERAL EVENTS
function RBDT_OnEvent(self, event, ...)
	--print("RBD Trade Event: " .. event)
	if event == "PLAYER_LOGIN" then
		if RBD_DB == nil then
			RBD_DB = {pullcount=20,hours=3};
		end
		RBDT_txtPullCount:SetNumber(RBD_DB.pullcount);
		RBDT_txtHours:SetNumber(RBD_DB.hours);		
	elseif event == "PLAYER_TARGET_CHANGED" then
		RBDT_GetPlayerInfo("target");
	elseif event == "TRADE_SHOW" then
		tradeSlot, tradeLoopCount, splitLoopCount = 1, 1, 1;
		RBDT_FindItem("Food", foodID);
	elseif event == "TRADE_CLOSED" then
		RBDT_btnTrade:Show();
		RBDT_btnAcceptTrade:Hide();
	elseif event == "PLAYER_LOGOUT" then
		RBD_DB.pullcount = RBDT_txtPullCount:GetNumber();
		RBD_DB.hours = RBDT_txtHours:GetNumber();
	end
end

--WINDOW IS SHOWN
function RBDT_OnShow(self)
	f:RegisterEvent("INSPECT_READY");
	RBDT_GetPlayerInfo("target");
	RBDT_Frame:RegisterEvent("PLAYER_TARGET_CHANGED");
	blockTrades = GetCVar("BlockTrades");
	RBDT_PrintBlockTrade();
end

--WINDOW IS HIDDEN
function RBDT_OnHide(self)
	RBDT_Frame:UnregisterEvent("TRADE_SHOW");
	RBDT_Frame:UnregisterEvent("TRADE_CLOSED");
	RBDT_Frame:UnregisterEvent("PLAYER_TARGET_CHANGED");
	f:UnregisterEvent("INSPECT_READY");
	SetCVar("BlockTrades",blockTrades);
	RBDT_PrintBlockTrade();
end

--TRADE BLOCKING
function RBDT_chkBlockTrade_CLICK (self)
	if RBDT_chkBlockTrade:GetChecked() then
		SetCVar("BlockTrades",1);
		blockTrades = 1;
	else
		SetCVar("BlockTrades",0);
		blockTrades = 0;
	end
	RBDT_PrintBlockTrade();
end

function RBDT_PrintBlockTrade()
	if blockTrades == 1 then
		print("Block Trades: On");
	else
		print("Block Trades: Off");
	end
end

--BEGIN TRADE
function RBDT_btnTRADE_CLICK(self, button, down)
	RBDT_Frame:RegisterEvent("TRADE_SHOW");
	InitiateTrade("target");
	RBDT_Frame:RegisterEvent("TRADE_CLOSED");
end

--ADD ITEMS TO TRADE
function RBDT_FindItem(buffType, ItemID)
	if RBD_DEBUG then print("Finding: "..buffType) end;
	--TODO if itemType checked
		if buffType == "Food" then
			RBDT_GetBagPosition(ItemID, RBD_DB.pullcount);
		elseif buffType == "Flask" then
			RBDT_GetBagPosition(ItemID, RBD_DB.hours);
		elseif buffType == "Potion" then
			--TODO if prolonged power checked
				RBDT_GetBagPosition(142117, RBD_DB.pullcount * 2);
			--else
				--give tank armor and dps
				--give healer mana and dps
				--give dps
				--RBDT_GetBagPosition(ItemID, RBD_DB.pullcount * 2);
			--end;
		elseif buffType == "AugmentRune" then
			RBDT_GetBagPosition(140587, RBD_DB.pullcount);
		elseif buffType == "VantusRune" then
			RBDT_GetBagPosition(ItemID, 1);
		end;
	--else
		--RBDT_NextItem();
	--end;
end;

function RBDT_AddItem(bag, slot)
	if RBD_DEBUG then print("Adding - bag:"..bag.." slot:"..slot) end;
	local numItems;
	PickupContainerItem(bag, slot);
	ClickTradeButton(tradeSlot);
	CheckTradeSlot(tradeSlot)
end;

function CheckTradeSlot(tradeSlot)
	if GetTradePlayerItemInfo(tradeSlot) == nil then
		if tradeLoopCount > 10 then
			tradeLoopCount = 1;
			tradeSlot = tradeSlot - 1;
			print("RBD - Unable to add item ");
			RBDT_NextItem();
		else
			RBDT_wait(0.1, CheckTradeSlot, tradeSlot);
			tradeLoopCount = tradeLoopCount + 1;
		end;
	else
		RBDT_NextItem();
		tradeLoopCount = 1;
	end;
end;

function RBDT_NextItem()
	if RBD_DEBUG then print("Next: "..tradeSlot) end;
	tradeSlot = tradeSlot + 1;
	if tradeSlot == 2 then
		--RBDT_FindItem("Flask", flaskID);
	--elseif tradeSlot == 3 then
		RBDT_FindItem("Potion", 142117);
	--elseif tradeSlot == 4 then
		--RBDT_FindItem("AugmentRune", 140587);
	--elseif tradeSlot == 5 then
		--RBDT_FindItem("VantusRune", );
	elseif tradeSlot > 2 then
		RBDT_btnAcceptTrade:Show();
		RBDT_btnTrade:Hide();
	end;
end;

--FIND ITEMS IN BAG
function RBDT_GetBagPosition(neededItemID, neededStackSize)
	if RBD_DEBUG then print("Finding item in bag") end;
	local itemStackSize, itemID, splitBag, splitSlot;
	local bagCount, itemFound, noEmptySlot = 0, false, false;
	for bag = 0, NUM_BAG_SLOTS do
		if GetContainerNumSlots(bag) > 0 then
			bagCount = bagCount + 1;
		end;
	end;
	
	if RBD_DEBUG then print("Checking Equal Stacks") end;
	--equal stacks
    for bag = 0, bagCount - 1 do
		if RBD_DEBUG then print("Equal Stacks - Looking in Bag: "..bag) end;
        for slot = 1, GetContainerNumSlots(bag) do
            _, itemStackSize, _, _, _, _, _, _, _, itemID = GetContainerItemInfo(bag, slot);
			if itemID == neededItemID then
				if itemStackSize == neededStackSize then
					if RBD_DEBUG then print("Equal Stacks - Item found!") end;
					RBDT_AddItem(bag, slot);
					itemFound = true;
					break;
				end;
            end;
        end;
    end;
	
	if RBD_DEBUG then print("Checking Larger Stacks - itemFound = "..string.format("%s", tostring(itemFound))) end;
	--larger stacks
	if not itemFound then
		local tempBag, tempSlot;
		for tempBag = 0, bagCount - 1 do
			if RBD_DEBUG then print("Larger Stacks - Looking in Bag: "..tempBag) end;
			for tempSlot = 1, GetContainerNumSlots(tempBag) do
				_, itemStackSize, _, _, _, _, _, _, _, itemID = GetContainerItemInfo(tempBag, tempSlot);
				if itemID == neededItemID then
					if itemStackSize > neededStackSize then
						if RBD_DEBUG then print("Larger Stacks - Item found: Bag"..tempBag.." Slot: "..tempSlot) end;
						local tempSplitBag, freeSlots;
						for tempSplitBag = 0, bagCount - 1 do
							freeSlots = GetContainerFreeSlots(tempSplitBag);
							if next(freeSlots) ~= nil then
								if RBD_DEBUG then print("Splitting: "..itemID.." splitBag: "..tempSplitBag.." splitSlot: "..freeSlots[1]) end;
								bag = tempBag;
								slot = tempSlot;
								splitBag = tempSplitBag;
								splitSlot = freeSlots[1];
								itemFound = true;
								break;
							end;
						end;
						if not itemFound then
							noEmptySlot = true;
						else
							break;
						end;
					end;
				end;
			end;
			if itemFound then
				break;
			end;
		end;
		if itemFound then
			if RBD_DEBUG then print("Calling split - Bag: "..bag.." Slot: "..slot.." splitBag: "..splitBag.." splitSlot: "..splitSlot) end;
			SplitItem(bag, slot, neededStackSize, splitBag, splitSlot);
		end;
	end;
	
	--error messages
	if noEmptySlot then
		local itemName = GetItemInfo(neededItemID);
		print("RBD - Error splitting "..itemName..". No empty bag slots!");
		RBDT_NextItem();
	elseif not itemFound then
		local itemName = GetItemInfo(neededItemID);
		print("RBD - Error adding "..itemName..". No stacks large enough!");
		RBDT_NextItem();
	end;
end;

function SplitItem(bag, slot, neededStackSize, splitBag, splitSlot)
	local itemStackSize, itemID;
	SplitContainerItem(bag, slot, neededStackSize);
	PickupContainerItem(splitBag, splitSlot);
	CheckSlitItem(splitBag, splitSlot);
end;

function CheckSlitItem(splitBag, splitSlot)
	if GetContainerItemInfo(splitBag, splitSlot) == nil then
		if RBD_DEBUG then print("splitCounter: "..splitLoopCount) end;
		if splitLoopCount > 10 then
			splitLoopCount = 1;
			tradeSlot = tradeSlot - 1;
			print("RBD - Unable to split item: ");
			RBDT_NextItem();
		else
			RBDT_wait(0.1, CheckSlitItem, splitBag, splitSlot);
			splitLoopCount = splitLoopCount + 1;
		end;
	else
		if RBD_DEBUG then print("Item split!"); end;
		RBDT_AddItem(splitBag, splitSlot);
		splitLoopCount = 1;
	end;
end;

--ACCEPT TRADE
function RBDT_btnACCEPT_CLICK(self, button, down)
	AcceptTrade();
end;
 
--GET TARGET CLASS AND SPEC
function RBDT_GetPlayerInfo(unit)
	FoundName = false;
    if not UnitExists(unit) then
		unit = "player";
    else
		unit = "target";
	end;
	
	--Check if player has specific buffs
	targetName, targetRealm = UnitName(unit)
	for key,checkName in pairs(RBD_CHARS) do
		if checkName == targetName then
			buffLookUp = RBD_CHAR_BUFFS[checkName];
			RBDT_SetItemIDs();
			RBDT_Class:SetText("Custom items for "..checkName);
			RBDT_Spec:SetText("");
			FoundName = true;
		end;
	end;
	
	if not FoundName and CheckInteractDistance(unit,1) then
        f.unit = unit;
        NotifyInspect(unit);
    end;
end;

--INSPECT TARGET & DETERMINE BUFFS
f:SetScript("OnEvent",function(self, event, ...)
    if self[event] then
        self[event](self, ...);
    end;
end);

function f:INSPECT_READY(guid)
    local unit = self.unit;
    if unit and UnitGUID(unit) == guid then
        self.unit = nil;
        local specID = GetInspectSpecialization(unit);
        local _, p_Spec, _, _, _, p_Class = GetSpecializationInfoByID(specID);
        self:RBDT_InspectReadyCallback(unit, specID, p_Spec, p_Class);
    end;
end;

function f:RBDT_InspectReadyCallback(unit, specID, p_Spec, p_Class)
	RBDT_Class:SetText(RBD_TRADE_CLASS..p_Class);
	RBDT_Spec:SetText(RBD_TRADE_SPEC..p_Spec);

	--Check if specialization has specific buffs
	if not FoundName then
		for key,checkSpec in pairs(RBD_SPECS) do
			if checkSpec == specID then
				FoundName = true;
				buffLookUp = RBD_SPEC_BUFFS[specID];
				RBDT_SetItemIDs();
				RBDT_Class:SetText("Custom items for "..RBDT_Spec.." "..RBDT_Class);
				RBDT_Spec:SetText("");
			end;
		end;
	end;
	if not FoundName then
		buffLookUp = RBD_DEFAULT[specID];
	end;
	RBDT_SetItemIDs();
end;

function RBDT_SetItemIDs()
	RBDT_SpecFood:SetText(RBD_FOOD[buffLookUp[1]][2]);
	foodID = RBD_FOOD[buffLookUp[1]][3];
	RBDT_SpecFlask:SetText(RBD_FLASK[buffLookUp[2]][2]);
	flaskID = RBD_FLASK[buffLookUp[2]][3];
	RBDT_SpecPotion:SetText(RBD_POTION[buffLookUp[3]][2]);
	potionID = RBD_POTION[buffLookUp[3]][3];
end;

function RBDT_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end
